[[[
 Show that a formal system of complexity N
 can't prove that a specific object has
 complexity > N + 1127.
 Formal system is a never halting lisp expression
 that displays pairs (lisp object, lower bound
 on its complexity).  E.g., (x(1111)) means
 that x has complexity H(x) greater than or equal to 4.
]]]

[ (<xy) tells if x is less than y ]
& (<xy) /.y0 /.x1 (<-x-y)
(<'(11)'(11))
(<'(11)'(111))
(<'(111)'(11))

[ Search list p for first s in pair (s,m) with H(s) >= m > n ]
[ (Returns 0/false to indicate not found.) ]
& (Epn) /.p 0 /(<n+-+p) ++p (E-pn)
(E'((x(11))(y(111)))'())
(E'((x(11))(y(111)))'(1))
(E'((x(11))(y(111)))'(11))
(E'((x(11))(y(111)))'(111))
(E'((x(11))(y(111)))'(1111))

++?0'!%  [[Universal binary computer U]]
         [[Put together program for U:]]
^#~'     [[Show crucial prefix so can size it]]
"(       [[begin literally]]

[ (<xy) tells if x is less than y ]
: (<xy) /.y1 /.x1 (<-x-y)    [[ BAD DEFINITION!!! ALWAYS TRUE ]]

[ Search list p for first s in pair (s,m) with H(s) >= m > n ]
[ (Returns 0/false to indicate not found.) ]
: (Epn) /.p 0 /(<n+-+p) ++p (E-pn)

[ (2n) = convert reversed binary to unary ]
: (2n) /.n() :k(2-n) /+n *1^kk ^kk

[ k is the size in bits of this program for U, ]
[ excluding the bits in the formal axiomatic system. ]
: k (2'(111 001 100 01)) [k = 1127 base 10 = 2147 base 8]

[Main Loop - t is depth limit (time),
             b is bits of FAS read so far (buffer)]
: (Ltb)
 : v ?t'!%b [run FAS for time t]
 : s (E-v^kb) [look for s-exp s that is proved to have complexity H(s)
               > 1127 + # of bits of FAS read]
 /s s       [Found it!  Output it and halt]
            [Contradiction: our value has complexity
             greater than our size!]
            [Our size is 1127 bits + the number of bits of
             the FAS that were read at the point that the
             search succeeded (some bits of the FAS may be
             unread).]
 /="!+v  (Lt^b*@()) [Read another bit of FAS]
 /="?+v  (L*1tb)    [Increase depth/time limit]
 "?     [Surprise, formal system halts, so we do too]

(L()())    [Initially, 0 depth limit and no bits read]

 )      [[end literally]]

#'
"(      [[begin literally]]

[[This is the FAS]]
,'((xy)(11))  [FAS = {"H((xy)) >= 2"}]

 )      [[end literally]]
