big.c

LISP Interpreter Run

[[[[ Omega in the limit from below! ]]]]

[[[
 (Wn) = the nth lower bound on the halting probability
 Omega = (the number of n-bit programs that halt when
 run on U for time n) divided by (2 to the power n).
]]]

&(Vkp) /.k /.+?n'!%p () '(1)
       (A(V-k*0p)(V-k*1p)0)

V:          (&(kp)(/(.k)(/(.(+(?n('(!(%)))p)))()('(1)))(A(V(-k
            )(*0p))(V(-k)(*1p))0)))


&(Wn) *0*".(R(Vn())n)

W:          (&(n)(*0(*.(R(Vn())n))))


[S = sum of three bits]
&(Sxyz) =x=yz

S:          (&(xyz)(=x(=yz)))


[C = carry of three bits]
&(Cxyz) /x/y1z/yz0

C:          (&(xyz)(/x(/y1z)(/yz0)))


[A = addition of reversed binary x and y]
[c = carryin]
&(Axyc) /.x /.y /c'(1)() (A'(0)yc)
        /.y (Ax'(0)c)
        *(S+x+yc)(A-x-y(C+x+yc))

A:          (&(xyc)(/(.x)(/(.y)(/c('(1))())(A('(0))yc))(/(.y)(
            Ax('(0))c)(*(S(+x)(+y)c)(A(-x)(-y)(C(+x)(+y)c)))))
            )


[Pad x to length k on right and reverse]
&(Rxk) /.x/.k() *0(Rx-k) ^(R-x-k)*+x()

R:          (&(xk)(/(.x)(/(.k)()(*0(Rx(-k))))(^(R(-x)(-k))(*(+
            x)()))))


[These lower bounds are zero until we
get a complete 7-bit character:]
(W'{0})

expression  (W('()))
value       (0.)

(W'{1})

expression  (W('(1)))
value       (0.0)

(W'{2})

expression  (W('(11)))
value       (0.00)

(W'{3})

expression  (W('(111)))
value       (0.000)

(W'{4})

expression  (W('(1111)))
value       (0.0000)

(W'{5})

expression  (W('(11111)))
value       (0.00000)

(W'{6})

expression  (W('(111111)))
value       (0.000000)

[Programs are now one 7-bit ASCII character.]
(W'{7})

expression  (W('(1111111)))
value       (0.1001001)

(W'{8})

expression  (W('(11111111)))
value       (0.10010100)

(W'{9})

expression  (W('(111111111)))
value       (0.100101000)

(W'{10})

expression  (W('(1111111111)))
value       (0.1001010000)

(W'{11})

expression  (W('(11111111111)))
value       (0.10010100000)

(W'{12})

expression  (W('(111111111111)))
value       (0.100101000000)

(W'{13})

expression  (W('(1111111111111)))
value       (0.1001010000000)

[Programs are now two 7-bit ASCII characters.]
(W'{14})

expression  (W('(11111111111111)))
value       (0.10100000111100)

(W'{15})

expression  (W('(111111111111111)))
value       (0.101000010001000)

(W'{16})

expression  (W('(1111111111111111)))
value       (0.1010000100010000)

(W'{17})

expression  (W('(11111111111111111)))
value       (0.10100001000100000)

(W'{18})

expression  (W('(111111111111111111)))
value       (0.101000010001000000)

(W'{19})

expression  (W('(1111111111111111111)))
value       (0.1010000100010000000)

(W'{20})

expression  (W('(11111111111111111111)))
value       (0.10100001000100000000)

[Programs are now three 7-bit ASCII characters.]
(W'{21})

expression  (W('(111111111111111111111)))
value       (0.101001001011001101110)

(W'{22})

expression  (W('(1111111111111111111111)))
value       (0.1010010011000111110100)

[At this point we run out of memory, even with
 512 megabytes of lisp storage.  The solution
 is either more storage, or a much more
 complicated lisp interpreter with garbage
 collection.  We will never reach the first
 program that loops forever.  The smallest
 example I know is  :(f)(f) (f)  which is
 10 characters = 70 bits.]
[
(W'{23})
]
End of LISP Run

Elapsed time is 4955 seconds.
