show.c

LISP Interpreter Run


[[[
 Show that H(Omega sub n) > n - 2177.
 Omega sub n is the first n bits of Omega.
]]]

[First test new stuff]

[<= for fractional binary numbers, i.e., is 0.x <= 0.y ?]
& (<xy) /.x 1
        /.y (<x'(0))
        /=+x+y (<-x-y)
        +y

<:          (&(xy)(/(.x)1(/(.y)(<x('(0)))(/(=(+x)(+y))(<(-x)(-
            y))(+y)))))

(<'(000)'(000))

expression  (<('(000))('(000)))
value       1

(<'(000)'(001))

expression  (<('(000))('(001)))
value       1

(<'(001)'(000))

expression  (<('(001))('(000)))
value       0

(<'(001)'(001))

expression  (<('(001))('(001)))
value       1

(<'(110)'(110))

expression  (<('(110))('(110)))
value       1

(<'(110)'(111))

expression  (<('(110))('(111)))
value       1

(<'(111)'(110))

expression  (<('(111))('(110)))
value       0

(<'(111)'(111))

expression  (<('(111))('(111)))
value       1

(<'()'(000))

expression  (<('())('(000)))
value       1

(<'()'(001))

expression  (<('())('(001)))
value       1

(<'(000)'())

expression  (<('(000))('()))
value       1

(<'(001)'())

expression  (<('(001))('()))
value       0


[Now run it all!]

++?0'!%  [ Universal binary computer U ]
         [ Put together program for U :]

^#~'     [ Show prefix prepended to program for first n bits of Omega ]
         [ so that we can see how many bits long the prepended prefix is.]

"(       [ begin literally ]

[W = lower bound on Omega obtained by
 running all n-bit programs for time n]
:(Vkp) /.k /.+?n'!%p () '(1)
       (A(V-k*0p)(V-k*1p)0)
:(Wn) [[[*0*".]]](R(Vn())n)  [No "0." in front]
[S = sum of three bits]
:(Sxyz) =x=yz
[C = carry of three bits]
:(Cxyz) /x/y1z/yz0
[A = addition of reversed binary x and y]
[c = carryin]
:(Axyc) /.x /.y /c'(1)() (A'(0)yc)
        /.y (Ax'(0)c)
        *(S+x+yc)(A-x-y(C+x+yc))
[Pad x to length k on right and reverse]
:(Rxk) /.x/.k() *0(Rx-k) ^(R-x-k)*+x()

[<= for fractional binary numbers, i.e., is 0.x <= 0.y ?]
:(<xy) /.x 1
       /.y (<x'(0))
       /=+x+y (<-x-y)
       +y

[List of all output of all n-bit programs p within time k.]
[ k is implicit argument.]
: (Bnp) /.n :v?k'!%p /.+v() +v
     [[ ^(B-n*0p)(B-n*1p) [wrong order] ]]
        ^(B-n^p'(0))(B-n^p'(1)) [right order] [[[ELIMINATE DUPLICATES???]]]

:w !%             [Read and execute from remainder of tape
                   a program to compute an n-bit
                   initial piece of Omega.
                   IMPORTANT:  If Omega = .???1000000...
                   here must take Omega = .???0111111...
                   I.e., w = first n bits of the latter
                   binary representation.]
:(Lk)             [Main Loop]
  :x     (Wk)     [Compute the kth lower bound on Omega]
  /(<wx) (Bw())   [Are the first n bits OK?  I.e, is w <= x ? ]
                  [If so, form the list of all output of n-bit
                   programs within time k, output it, and halt.
                   This is bigger than anything of complexity
                   less than or equal to n!]
[I.e., this total output (Bw()) will be bigger than each individual output,
 and therefore must come from a program with more than n bits.
 Hence the size in bits of this prefix (= 2177) + the size in
 bits of any program for the first n bits of Omega must be
 greater than n.  Hence H(Omega sub n) > n - 2177!
]
  (L*1k)          [If first n bits not OK, bump k and loop.]

(L())         [Start main loop running with k initially zero.]

 )            [end literally]

#'            [Above prefix in binary is prepended to a
               program for U to compute the first n bits of Omega.]
"(            [begin literally]

[[[ Program to compute the first n bits of Omega: ]]]
[Cheat: test with the 7 bit approximation to Omega!]
[(Could also test this with 14 bit and 21 bit Omega approximations)]
[(Hence n = 7, and final output will have complexity greater than 7.)]
'(1001001)

 )            [end literally]

expression  (+(+(?0('(!(%)))(^(#(~('(:(Vkp)/.k/.+?n'!%p()'(1)(
            A(V-k*0p)(V-k*1p)0):(Wn)(R(Vn())n):(Sxyz)=x=yz:(Cx
            yz)/x/y1z/yz0:(Axyc)/.x/.y/c'(1)()(A'(0)yc)/.y(Ax'
            (0)c)*(S+x+yc)(A-x-y(C+x+yc)):(Rxk)/.x/.k()*0(Rx-k
            )^(R-x-k)*+x():(<xy)/.x1/.y(<x'(0))/=+x+y(<-x-y)+y
            :(Bnp)/.n:v?k'!%p/.+v()+v^(B-n^p'(0))(B-n^p'(1)):w
            !%:(Lk):x(Wk)/(<wx)(Bw())(L*1k)(L())))))(#('('(100
            1001))))))))
show        (:(Vkp)/.k/.+?n'!%p()'(1)(A(V-k*0p)(V-k*1p)0):(Wn)
            (R(Vn())n):(Sxyz)=x=yz:(Cxyz)/x/y1z/yz0:(Axyc)/.x/
            .y/c'(1)()(A'(0)yc)/.y(Ax'(0)c)*(S+x+yc)(A-x-y(C+x
            +yc)):(Rxk)/.x/.k()*0(Rx-k)^(R-x-k)*+x():(<xy)/.x1
            /.y(<x'(0))/=+x+y(<-x-y)+y:(Bnp)/.n:v?k'!%p/.+v()+
            v^(B-n^p'(0))(B-n^p'(1)):w!%:(Lk):x(Wk)/(<wx)(Bw()
            )(L*1k)(L()))
size        311(467)/2177(4201)
value       ($()0123456789;<>ABCDEFGHIJKLMNOPQRSTUVWXYZ\]_`abc
            defghijklmnopqrstuvwxyz|})

End of LISP Run

Elapsed time is 0 seconds.
