lisp.c

LISP Interpreter Run

[ LISP test run ]
'(abc)

expression  ('(abc))
value       (abc)

+'(abc)

expression  (+('(abc)))
value       a

-'(abc)

expression  (-('(abc)))
value       (bc)

*'(ab)'(cd)

expression  (*('(ab))('(cd)))
value       ((ab)cd)

.'a

expression  (.('a))
value       1

.'(abc)

expression  (.('(abc)))
value       0

='(ab)'(ab)

expression  (=('(ab))('(ab)))
value       1

='(ab)'(ac)

expression  (=('(ab))('(ac)))
value       0

-,-,-,-,-,-,'(abcdef)

expression  (-(,(-(,(-(,(-(,(-(,(-(,('(abcdef))))))))))))))
display     (abcdef)
display     (bcdef)
display     (cdef)
display     (def)
display     (ef)
display     (f)
value       ()

/0'x'y

expression  (/0('x)('y))
value       y

/1'x'y

expression  (/1('x)('y))
value       x

!,'/1'x'y

expression  (!(,('(/1('x)('y)))))
display     (/1('x)('y))
value       x

(*"&*()*,'/1'x'y())

expression  ((*&(*()(*(,('(/1('x)('y))))()))))
display     (/1('x)('y))
value       x

('&(xy)y 'a 'b)

expression  (('(&(xy)y))('a)('b))
value       b

: x 'a : y 'b *x*y()

expression  (('(&(x)(('(&(y)(*x(*y()))))('b))))('a))
value       (ab)

[ first atom ]
: (Fx)/.,xx(F+x) (F'((((a)b)c)d))

expression  (('(&(F)(F('((((a)b)c)d)))))('(&(x)(/(.(,x))x(F(+x
            ))))))
display     ((((a)b)c)d)
display     (((a)b)c)
display     ((a)b)
display     (a)
display     a
value       a

[ concatenation ]
:(Cxy) /.,xy *+x(C-xy) (C'(ab)'(cd))

expression  (('(&(C)(C('(ab))('(cd)))))('(&(xy)(/(.(,x))y(*(+x
            )(C(-x)y))))))
display     (ab)
display     (b)
display     ()
value       (abcd)

?'()'
:(Cxy) /.,xy *+x(C-xy) (C'(ab)'(cd))
'()

expression  (?('())('(('(&(C)(C('(ab))('(cd)))))('(&(xy)(/(.(,
            x))y(*(+x)(C(-x)y)))))))('()))
value       (?)

?'(1)'
:(Cxy) /.,xy *+x(C-xy) (C'(ab)'(cd))
'()

expression  (?('(1))('(('(&(C)(C('(ab))('(cd)))))('(&(xy)(/(.(
            ,x))y(*(+x)(C(-x)y)))))))('()))
value       (?)

?'(11)'
:(Cxy) /.,xy *+x(C-xy) (C'(ab)'(cd))
'()

expression  (?('(11))('(('(&(C)(C('(ab))('(cd)))))('(&(xy)(/(.
            (,x))y(*(+x)(C(-x)y)))))))('()))
value       (?(ab))

?'(111)'
:(Cxy) /.,xy *+x(C-xy) (C'(ab)'(cd))
'()

expression  (?('(111))('(('(&(C)(C('(ab))('(cd)))))('(&(xy)(/(
            .(,x))y(*(+x)(C(-x)y)))))))('()))
value       (?(b)(ab))

?'(1111)'
:(Cxy) /.,xy *+x(C-xy) (C'(ab)'(cd))
'()

expression  (?('(1111))('(('(&(C)(C('(ab))('(cd)))))('(&(xy)(/
            (.(,x))y(*(+x)(C(-x)y)))))))('()))
value       (((abcd))()(b)(ab))


[ d: x goes to (xx) ]
& (dx) *,x*x()

d:          (&(x)(*(,x)(*x())))

[ e really doubles length of string each time ]
& (ex) *,xx

e:          (&(x)(*(,x)x))

(d(d(d(d(d(d(d(d()))))))))

expression  (d(d(d(d(d(d(d(d()))))))))
display     ()
display     (()())
display     ((()())(()()))
display     (((()())(()()))((()())(()())))
display     ((((()())(()()))((()())(()())))(((()())(()()))((()
            ())(()()))))
display     (((((()())(()()))((()())(()())))(((()())(()()))(((
            )())(()()))))((((()())(()()))((()())(()())))(((()(
            ))(()()))((()())(()())))))
display     ((((((()())(()()))((()())(()())))(((()())(()()))((
            ()())(()()))))((((()())(()()))((()())(()())))(((()
            ())(()()))((()())(()())))))(((((()())(()()))((()()
            )(()())))(((()())(()()))((()())(()()))))((((()())(
            ()()))((()())(()())))(((()())(()()))((()())(()()))
            ))))
display     (((((((()())(()()))((()())(()())))(((()())(()()))(
            (()())(()()))))((((()())(()()))((()())(()())))((((
            )())(()()))((()())(()())))))(((((()())(()()))((()(
            ))(()())))(((()())(()()))((()())(()()))))((((()())
            (()()))((()())(()())))(((()())(()()))((()())(()())
            )))))((((((()())(()()))((()())(()())))(((()())(()(
            )))((()())(()()))))((((()())(()()))((()())(()())))
            (((()())(()()))((()())(()())))))(((((()())(()()))(
            (()())(()())))(((()())(()()))((()())(()()))))(((((
            )())(()()))((()())(()())))(((()())(()()))((()())((
            )())))))))
value       ((((((((()())(()()))((()())(()())))(((()())(()()))
            ((()())(()()))))((((()())(()()))((()())(()())))(((
            ()())(()()))((()())(()())))))(((((()())(()()))((()
            ())(()())))(((()())(()()))((()())(()()))))((((()()
            )(()()))((()())(()())))(((()())(()()))((()())(()()
            ))))))((((((()())(()()))((()())(()())))(((()())(()
            ()))((()())(()()))))((((()())(()()))((()())(()()))
            )(((()())(()()))((()())(()())))))(((((()())(()()))
            ((()())(()())))(((()())(()()))((()())(()()))))((((
            ()())(()()))((()())(()())))(((()())(()()))((()())(
            ()())))))))(((((((()())(()()))((()())(()())))(((()
            ())(()()))((()())(()()))))((((()())(()()))((()())(
            ()())))(((()())(()()))((()())(()())))))(((((()())(
            ()()))((()())(()())))(((()())(()()))((()())(()()))
            ))((((()())(()()))((()())(()())))(((()())(()()))((
            ()())(()()))))))((((((()())(()()))((()())(()())))(
            ((()())(()()))((()())(()()))))((((()())(()()))((()
            ())(()())))(((()())(()()))((()())(()())))))(((((()
            ())(()()))((()())(()())))(((()())(()()))((()())(()
            ()))))((((()())(()()))((()())(()())))(((()())(()()
            ))((()())(()()))))))))

(e(e(e(e(e(e(e(e()))))))))

expression  (e(e(e(e(e(e(e(e()))))))))
display     ()
display     (())
display     ((())())
display     (((())())(())())
display     ((((())())(())())((())())(())())
display     (((((())())(())())((())())(())())(((())())(())())(
            (())())(())())
display     ((((((())())(())())((())())(())())(((())())(())())
            ((())())(())())((((())())(())())((())())(())())(((
            ())())(())())((())())(())())
display     (((((((())())(())())((())())(())())(((())())(())()
            )((())())(())())((((())())(())())((())())(())())((
            (())())(())())((())())(())())(((((())())(())())(((
            ))())(())())(((())())(())())((())())(())())((((())
            ())(())())((())())(())())(((())())(())())((())())(
            ())())
value       ((((((((())())(())())((())())(())())(((())())(())(
            ))((())())(())())((((())())(())())((())())(())())(
            ((())())(())())((())())(())())(((((())())(())())((
            ())())(())())(((())())(())())((())())(())())((((()
            )())(())())((())())(())())(((())())(())())((())())
            (())())((((((())())(())())((())())(())())(((())())
            (())())((())())(())())((((())())(())())((())())(()
            )())(((())())(())())((())())(())())(((((())())(())
            ())((())())(())())(((())())(())())((())())(())())(
            (((())())(())())((())())(())())(((())())(())())(((
            ))())(())())

End of LISP Run

Elapsed time is 0 seconds.
