show.c

LISP Interpreter Run

[[[
 First steps with my new construction for
 a self-delimiting universal Turing machine.
 We show that
    H((xy)) <= H(x) + H(y) + 56.
 Consider a bit string x of length |x|.
 We also show that
    H(x) <= 2|x| + 168
 and that
    H(x) <= |x| + H(|x|) + 525.
]]]

?0
':(f) :x@ :y@ /=xy *x(f) () (f)
'(0011001101)

expression  (?0('(('(&(f)(f)))('(&()(('(&(x)(('(&(y)(/(=xy)(*x
            (f))())))(@))))(@))))))('(0011001101)))
value       (((0101)))

[ This is 168 bits long: ]
~'"( :(f) :x@ :y@ /=xy *x(f) () (f) )

expression  (~('(:(f):x@:y@/=xy*x(f)()(f))))
show        (:(f):x@:y@/=xy*x(f)()(f))
size        24(30)/168(250)
value       (:(f):x@:y@/=xy*x(f)()(f))

[ Here are the 168 bits: ]
#'"( :(f) :x@ :y@ /=xy *x(f) () (f) )

expression  (#('(:(f):x@:y@/=xy*x(f)()(f))))
value       (0111010010100011001100101001011101011110001000000
            01110101111001100000001011110111101111100011110010
            10101011110000101000110011001010010101000010100101
            0100011001100101001)

[ Here is the self-delimiting universal Turing machine! ]
[ (with slightly funny handling of out-of-tape condition) ]
& (Up) ++?0'!%p

U:          (&(p)(+(+(?0('(!(%)))p))))

[Show that H(x) <= 2|x| + 168]
(U
 ^ #'"( :(f) :x@ :y@ /=xy *x(f) () (f) )
   '(0011001101)
)

expression  (U(^(#('(:(f):x@:y@/=xy*x(f)()(f))))('(0011001101)
            )))
value       (0101)

(U
 ^ #'"( :(f) :x@ :y@ /=xy *x(f) () (f) )
   '(0011001100)
)

expression  (U(^(#('(:(f):x@:y@/=xy*x(f)()(f))))('(0011001100)
            )))
value       !

(U
 ^ #~'"( *!%*!%() ) [The length of this bit string is the]
                    [constant c = 56 in H(x,y) <= H(x)+H(y)+c.]
 ^ #'"( :(f) :x@ :y@ /=xy *x(f) () (f) )
 ^ '(0011001101)
 ^ #'"( :(f) :x@ :y@ /=xy *x(f) () (f) )
   '(1100110001)
)

expression  (U(^(#(~('(*!%*!%()))))(^(#('(:(f):x@:y@/=xy*x(f)(
            )(f))))(^('(0011001101))(^(#('(:(f):x@:y@/=xy*x(f)
            ()(f))))('(1100110001)))))))
show        (*!%*!%())
size        8(10)/56(70)
value       ((0101)(1010))

& (Dk) /=0+k *1(D-k) /.-k () *0-k [D = decrement reverse binary]

D:          (&(k)(/(=0(+k))(*1(D(-k)))(/(.(-k))()(*0(-k)))))

,(D,(D,(D,(D,'(001)))))

expression  (,(D(,(D(,(D(,(D(,('(001)))))))))))
display     (001)
display     (11)
display     (01)
display     (1)
display     ()
value       ()

(U
 ^ #~'       [Show that H(x) <= |x| + H(|x|) + 525.]
"(           [begin literally]
   : (Re) /.e() ^(R-e)*+e()          [R = reverse  ]
   : (Dk) /=0+k *1(D-k) /.-k () *0-k [D = decrement]
   : (Lk) /.k () *@(L(Dk))           [L = loop     ]
   (L(R!%))
 )           [end literally]
 ^ #'"( '(1000) )  [ lisp expression that evaluates to binary 8, ]
   '(0000 0001)    [ so 8 bits of data follows the header ]
)

expression  (U(^(#(~('(:(Re)/.e()^(R-e)*+e():(Dk)/=0+k*1(D-k)/
            .-k()*0-k:(Lk)/.k()*@(L(Dk))(L(R!%))))))(^(#('('(1
            000))))('(00000001)))))
show        (:(Re)/.e()^(R-e)*+e():(Dk)/=0+k*1(D-k)/.-k()*0-k:
            (Lk)/.k()*@(L(Dk))(L(R!%)))
size        75(113)/525(1015)
value       (00000001)

End of LISP Run

Elapsed time is 0 seconds.
